#include <stdio.h>
#define swap(a, b) (a == b ? : ((a) = (a) ^ (b), (b) = (a) ^ (b), (a) = (a) ^ (b)))
struct image
{
  int width;
  int height;
  int * pixels;
};
int maxDepth;
void readImage(char const * fileName, struct image * imageToRead)
{
  FILE * fp;
  char someString[128];
  int i, someInt, tmp[3];
  fp = fopen(fileName, "rt");
  fgets(someString, 128, fp);
  while (1)
  {
    if (fgetc(fp) == '#')
      fgets(someString, 128, fp);
    else
      break;
  }
  fseek(fp, -1, SEEK_CUR);
  fscanf(fp, "%d%d", &imageToRead->width, &imageToRead->height);
  imageToRead->pixels = (int*)malloc(imageToRead->width * imageToRead->height * sizeof(int));
  fscanf(fp, "%d", &someInt);
  for (i = 0; i <= imageToRead->width * imageToRead->height - 1; i++)
  {
    fscanf(fp, "%d%d%d", &tmp[0], &tmp[1], &tmp[2]);
    imageToRead->pixels[i] = (tmp[0] << 16) + (tmp[1] << 8) + (tmp[2] << 0);
  }
  fclose(fp);
}
void writeImage(char const * fileName, struct image * imageToWrite)
{
  FILE * fp;
  int i;
  fp = fopen(fileName, "wt");
  fprintf(fp, "%s\n%s\n%d %d\n255\n", "P3", "# Created with rotate", imageToWrite->width, imageToWrite->height);
  for (i = 0; i <= imageToWrite->width * imageToWrite->height - 1; i++)
    fprintf(fp, "%d\n%d\n%d\n",
        (imageToWrite->pixels[i] & 0xFF0000) >> 16,
        (imageToWrite->pixels[i] & 0xFF00)   >> 8,
        (imageToWrite->pixels[i] & 0xFF)     >> 0);
  fclose(fp);
}
#define xcurEx(p, w, h) ((p) % (w))
#define ycurEx(p, w, h) ((p) / (w))
#define xrotEx(p, w, h) ((p) % (h))
#define yrotEx(p, w, h) ((p) / (h))
#define nextEx(p, w, h) (((h) - 1 - ycurEx(p, w, h)) + xcurEx(p, w, h) * (h))
#define prevEx(p, w, h) (yrotEx(p, w, h) + ((h) - 1 - xrotEx(p, w, h)) * (w))


#define next(p) nextEx(p, imageWidth, imageHeight)
#define prev(p) prevEx(p, imageWidth, imageHeight)
int realPixelPosition(int pixel, int imageWidth, int imageHeight, int depth)
{
  int curPixel = pixel, curExecPixel = -1;
  if (depth == 2)
    return pixel;
  if (depth > maxDepth)
    maxDepth = depth;
  while (prev(curPixel) < curPixel)
    curPixel = prev(curPixel);
  if (next(pixel) < pixel)
    while (prev(curPixel) > curExecPixel && prev(curPixel) < pixel)
    {
      curExecPixel = prev(curPixel);
      curPixel = realPixelPosition(curExecPixel, imageWidth, imageHeight, depth + 1);
    }
  return curPixel;
}
#undef next
#undef prev
#define next(p) nextEx(p, imageToRotate->width, imageToRotate->height)
#define prev(p) prevEx(p, imageToRotate->width, imageToRotate->height)
void myRotateImage(struct image * imageToRotate)
{
  int i;
  maxDepth = 0;
  for (i = 0; i <= imageToRotate->width * imageToRotate->height - 1; i++)
    if (next(i) > i)
      swap(imageToRotate->pixels[realPixelPosition(i, imageToRotate->width, imageToRotate->height, 1)],
          imageToRotate->pixels[next(i)]);
  for (i = 0; i <= imageToRotate->width * imageToRotate->height - 1; i++)
    if (next(i) < i)
      swap(imageToRotate->pixels[realPixelPosition(i, imageToRotate->width, imageToRotate->height, 1)],
          imageToRotate->pixels[next(i)]);
  swap(imageToRotate->width, imageToRotate->height);
}
#undef next
#undef prev


#define next(p) nextEx(p, imageToRotate->width, imageToRotate->height)
void rotateImageGower(struct image * imageToRotate)
{
  int i, curPixel;
  for (i = 0; i <= imageToRotate->width * imageToRotate->height - 1; i++)
  {
    curPixel = next(i);
    while (curPixel > i)
      curPixel = next(curPixel);
    if (curPixel == i)
    {
      curPixel = next(curPixel);
      while (curPixel != i)
      {
        swap(imageToRotate->pixels[i], imageToRotate->pixels[curPixel]);
        curPixel = next(curPixel);
      }
    }
  }
  swap(imageToRotate->width, imageToRotate->height);
}
#undef next
#undef xcurEx
#undef ycurEx
#undef xrotEx
#undef yrotEx
#undef nextEx
#undef prevEx
int main(int argc, char const * argv[])
{
  struct image imageToRotate;
  printf("Reading... ");
  fflush(stdout);
  readImage(argv[1], &imageToRotate);
  printf("Done.\nRotating... ");
  fflush(stdout);
  /*myRotateImage(&imageToRotate);
  printf("Done. maxDepth = %d\nWriting... ", maxDepth);
  fflush(stdout);*/
  rotateImageGower(&imageToRotate);
  printf("Done.\nWriting... ");
  fflush(stdout);
  writeImage(argv[2], &imageToRotate);
  printf("Done.\n");
  fflush(stdout);
  free(imageToRotate.pixels);
  return 0;
}
